﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RabbitMQ.Client;

namespace Publisher
{
    class Program
    {
        static void Main(string[] args)
        {
            var factory = new ConnectionFactory();
            factory.HostName = "localhost";

            using (var con = factory.CreateConnection())
            {
                using (var channel = con.CreateModel())
                {
                    var basicProperties = channel.CreateBasicProperties();
                    basicProperties.Persistent = true;

                    channel.QueueDeclare(queue: "hello",
                                    durable: false,
                                    exclusive: false,
                                    autoDelete: false,
                                    arguments: null);

                    var msg = "Hallo Welt!";
                    var body = Encoding.UTF8.GetBytes(msg);

                    while (Console.ReadKey().Key == ConsoleKey.Enter)
                    {
                        channel.BasicPublish(exchange: "",
                                 routingKey: "hello",
                                 basicProperties: basicProperties,
                                 body: body);
                        Console.WriteLine("Message sent!");
                    }
                }
            }
        }
    }
}
