﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using RabbitMQ.Client;
using RabbitMQ.Client.Events;

namespace Publisher
{
    class Program
    {
        static void Main(string[] args)
        {
            var factory = new ConnectionFactory();
            factory.HostName = "localhost";

            using (var con = factory.CreateConnection())
            {
                using (var channel = con.CreateModel())
                {
                    var replyQueue = channel.QueueDeclare().QueueName;
                    var basicProperties = channel.CreateBasicProperties();
                    basicProperties.Persistent = true;
                    basicProperties.ReplyTo = replyQueue;
                    basicProperties.CorrelationId = Guid.NewGuid().ToString();

                    channel.QueueDeclare(queue: "worker",
                                    durable: false,
                                    exclusive: false,
                                    autoDelete: false,
                                    arguments: null);

                    var url = "http://www.dotnetpro.de";
                    var body = Encoding.UTF8.GetBytes(url);


                    var consumer = new EventingBasicConsumer(channel);
                    consumer.Received += (m, e) =>
                    {
                        var response = e.Body;
                        var content = Encoding.UTF8.GetString(response);
                        Console.WriteLine(content);
                    };
                    channel.BasicConsume(queue: replyQueue, consumer: consumer, autoAck: true);

                    while (Console.ReadKey().Key == ConsoleKey.Enter)
                    {
                        channel.BasicPublish(exchange: "",
                                 routingKey: "worker",
                                 basicProperties: basicProperties,
                                 body: body);
                        Console.WriteLine("Work published.");
                    }
                }
            }
        }
    }
}
